## openmolcas 19.11

=== CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#                                                                      *
# Copyright (C) 2014-2016, Steven Vancoillie                           *
#               2014-2019, Ignacio Fdez. Galván                        *
#               2015, Stefan Knecht                                    *
#***********************************************************************
# Global CMakeLists.txt file for building Molcas with CMake.
#
# Steven Vancoillie - Spring 2014, on a Saturday afternoon, with coffee
# Ignacio Fdez. Galván made several improvements / additions
# Lasse Sørensen - Mac CMP0042 fix

cmake_minimum_required (VERSION 2.8.11)
#set (CMAKE_VERBOSE_MAKEFILE true)
if (POLICY CMP0042)
        cmake_policy(SET CMP0042 NEW)
endif ()
if (POLICY CMP0045)
        cmake_policy(SET CMP0045 NEW)
endif ()
if (POLICY CMP0074)
        cmake_policy(SET CMP0074 NEW)
endif ()
if (POLICY CMP0004)
        cmake_policy(SET CMP0004 NEW)
endif ()

# Prevent in-source builds
# If an in-source build is attempted, you will still need to clean up a few files manually.
set (CMAKE_DISABLE_SOURCE_CHANGES ON)
set (CMAKE_DISABLE_IN_SOURCE_BUILD ON)
get_filename_component (sourcedir "${CMAKE_SOURCE_DIR}" REALPATH)
get_filename_component (binarydir "${CMAKE_BINARY_DIR}" REALPATH)
if ("${sourcedir}" STREQUAL "${binarydir}")
        message(FATAL_ERROR "In-source builds in ${CMAKE_BINARY_DIR} are not "
                "allowed, please remove ./CMakeCache.txt and ./CMakeFiles/, create a "
                "separate build directory and run cmake from there.")
endif ()

# workaround for CMake bug 14874
# (i.e., fix for files with same name in different directories)
if (${CMAKE_VERSION} VERSION_LESS 3.1)
        if (NOT DEFINED CMAKE_Fortran_ARCHIVE_CREATE)
                set(CMAKE_Fortran_ARCHIVE_CREATE "<CMAKE_AR> cq <TARGET> <LINK_FLAGS> <OBJECTS>")
        endif ()
        if (NOT DEFINED CMAKE_Fortran_ARCHIVE_APPEND)
                set(CMAKE_Fortran_ARCHIVE_APPEND "<CMAKE_AR> q  <TARGET> <LINK_FLAGS> <OBJECTS>")
        endif ()
        if (NOT DEFINED CMAKE_C_ARCHIVE_CREATE)
                set(CMAKE_C_ARCHIVE_CREATE "<CMAKE_AR> cq <TARGET> <LINK_FLAGS> <OBJECTS>")
        endif ()
        if (NOT DEFINED CMAKE_C_ARCHIVE_APPEND)
                set(CMAKE_C_ARCHIVE_APPEND "<CMAKE_AR> q  <TARGET> <LINK_FLAGS> <OBJECTS>")
        endif ()
        if (NOT DEFINED CMAKE_CXX_ARCHIVE_CREATE)
                set(CMAKE_CXX_ARCHIVE_CREATE "<CMAKE_AR> cq <TARGET> <LINK_FLAGS> <OBJECTS>")
        endif ()
        if (NOT DEFINED CMAKE_CXX_ARCHIVE_APPEND)
                set(CMAKE_CXX_ARCHIVE_APPEND "<CMAKE_AR> q  <TARGET> <LINK_FLAGS> <OBJECTS>")
        endif ()
endif ()

# discover some necessary tools
find_program (GIT "git")
find_program (PERL "perl")
mark_as_advanced(FORCE GIT PERL)

FIND_PACKAGE(PythonInterp 3.0)
if (NOT PYTHONINTERP_FOUND)
        FIND_PACKAGE(PythonInterp 2.7)
endif ()

################################################################################
#                                                                              #
# Options                                                                      #
#                                                                              #
################################################################################

# The build type, specifies the different optimization types.
if (NOT DEFINED CMAKE_BUILD_TYPE OR "${CMAKE_BUILD_TYPE}" STREQUAL "")
        set (CMAKE_BUILD_TYPE "Release" CACHE STRING
                "Type of build, options are: None (CFLAGS/FFLAGS can be used), Debug, Garble, RelWithDebInfo, Release, Fast."
                FORCE
                )
endif ()
set_property (CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS None Debug Garble RelWithDebInfo Release Fast)

# The place where Molcas is installed with make install.
if (NOT DEFINED CMAKE_INSTALL_PREFIX)
        set (CMAKE_INSTALL_PREFIX "/opt/molcas" CACHE STRING
                "Location where Molcas will be installed.")
endif ()

option (DEBUGPRINT "Enable excessive print statements for debugging." OFF)
option (DEBUGTRACE "Enable tracing print statements for debugging." OFF)

set (DEBUG_DEFS_DESC "Additional debugging definitions.")
if (DEFINED DEBUG_DEFS)
        separate_arguments(DEBUG_DEFS)
        set (DEBUG_DEFS "${DEBUG_DEFS}" CACHE STRING "${DEBUG_DEFS_DESC}" FORCE)
else ()
        set (DEBUG_DEFS "" CACHE STRING "${DEBUG_DEFS_DESC}")
endif ()

option (BUILD_SHARED_LIBS "Build dynamically-linked molcas library." OFF)
option (BUILD_STATIC_LIB "Build statically-linked molcas library too." OFF)
if (BUILD_SHARED_LIBS)
        mark_as_advanced (CLEAR BUILD_STATIC_LIB)
else ()
        mark_as_advanced (FORCE BUILD_STATIC_LIB)
endif ()

option (MPI "Enable MPI parallellization." OFF)
option (GA "Use Global Arrays library." OFF)

option (OPENMP "Enable multi-threading." OFF)

option (BOUNDS "Enable bounds checking (only gfortran >= 4.8)." OFF)

option (EXPERT "Show advanced CMake cache entries in GUI)." OFF)

option (BIGOT "Do not allow any compiler warning (treat them as errors)." OFF)

set (LINALG_OPTIONS "Choose linear algebra library, options: Internal (default), Runtime, MKL, OpenBLAS, ACML, Accelerate.")
if (DEFINED LINALG)
        set (LINALG "${LINALG}" CACHE STRING "${LINALG_OPTIONS}")
        if (NOT ";Internal;Runtime;MKL;OpenBLAS;ACML;Accelerate;" MATCHES ";${LINALG};")
                message (FATAL_ERROR "Unsuported LINALG: ${LINALG}")
        endif ()
else ()
        set (LINALG "Internal"  CACHE STRING "${LINALG_OPTIONS}")
endif ()
set_property (CACHE LINALG PROPERTY STRINGS Internal Runtime MKL OpenBLAS ACML Accelerate)

option (CUBLAS "Enable CUDA BLAS library." OFF)
option (NVBLAS "Enable NVidia BLAS library." OFF)

option (FDE "Enable Frozen-density-embedding (FDE) interface." OFF)
option (GROMACS "Compile Gromacs interface." OFF)
option (BLOCK "Activate BLOCK-DMRG support." OFF)
option (CHEMPS2 "Activate CheMPS2-DMRG support." OFF)

option (GPERFTOOLS "Activate gperftools CPU profiling." OFF)
option (GCOV "Activate code coverage profiling (use with Debug/-O0)." OFF)
option (HDF5 "Activate HDF5 support for wavefunction format." ON)

option (TOOLS "Compile supported tools." OFF)

option (CTEST "Enable CTest." OFF)
mark_as_advanced (CTEST)

# External projects
option (MSYM       "Activate MSYM support (requires External/libmsym submodule)."                               OFF)
option (DMRG       "Activate QCMaquis DMRG driver and library."                                                 OFF)
option (DMRG_DEBUG "Enable DEBUG print in QCMaquis driver."                                                     OFF)

if (DMRG)
        mark_as_advanced (CLEAR DMRG_DEBUG)
        # Name and e-mail required for downloading QCMaquis
        # Try to get the real name from the system account information
        if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
                set(QCMaquis_NAME_GET_CMD "id -F")
        else()
        # should we distinguish other platforms?
                set(QCMaquis_NAME_GET_CMD "sh" "-c" "getent passwd $USER | awk -F: '{print \$5}'")
        endif()
        execute_process (
                COMMAND ${QCMaquis_NAME_GET_CMD}
                OUTPUT_VARIABLE QCMaquis_NAME_
                OUTPUT_STRIP_TRAILING_WHITESPACE
        )
        set (QCMaquis_NAME ${QCMaquis_NAME_} CACHE STRING "Your name (required for downloading QCMaquis)")

        # Update QCMaquis flag. Off by default.
        # QCMaquis must be updated manually, as there might be QCMaquis upstream changes even when OpenMolcas is not changed,
        # or vice versa. Running cmake with QCMaquis_UPDATE=ON will force-update QCMaquis.
        if (NOT QCMaquis_UPDATE)
                set (QCMaquis_UPDATE OFF CACHE STRING "Trigger QCMaquis update" FORCE)
        endif()

        # try to get the e-mail address from git config (TODO: is there a better option?)
        execute_process (
                COMMAND ${GIT} "config" "user.email"
                OUTPUT_VARIABLE QCMaquis_EMAIL_
                OUTPUT_STRIP_TRAILING_WHITESPACE
        )
        set (QCMaquis_EMAIL ${QCMaquis_EMAIL_} CACHE STRING "Your e-mail address (required for downloading QCMaquis)")

        # Prepare variables for QCMaquis: separate name and surname
        set (QCMaquis_NAME_LIST ${QCMaquis_NAME})

        separate_arguments (QCMaquis_NAME_LIST)
        list(LENGTH QCMaquis_NAME_LIST qcm_name_len)
        if (qcm_name_len LESS 2)
                message (FATAL_ERROR
                        "Your name has been specified as: " ${QCMaquis_NAME} "\n"
                        "Please specify both name and surname. If you have only one name, please specify it twice.")
        endif()

        # Separate first name from the last name
        # Currently, only the first word is treated by QCMaquis as the first name,
        # all the rest is considered surnames -- to accomodate multiple surnames common in the Spanish-speaking
        # areas or suffixes as Jr., III etc. Middle names are therefore incorrectly considered parts of
        # the last name. However, this has no influence on the QCMaquis download.
        list(GET QCMaquis_NAME_LIST 0 QCMaquis_GIVEN_NAME)
        list(REMOVE_AT QCMaquis_NAME_LIST 0)
        foreach(arg ${QCMaquis_NAME_LIST})
                      set(QCMaquis_SURNAME "${QCMaquis_SURNAME} ${arg}")
        endforeach()

        # Set QCMaquis download URL and path to the download script
        set (QCMaquis_URL "https://scine.ethz.ch/download/")
        set (QCMaquis_dl_SCRIPT "${CMAKE_SOURCE_DIR}/src/qcmaquis/get_qcmaquis.sh")
else ()
        mark_as_advanced (FORCE DMRG_DEBUG)
endif ()
option (GEN1INT    "Enable Gen1Int library for 1-electron integrals."                                           OFF)
option (NECI       "Activate NECI support (requires External/NECI submodule)."                                  OFF)
option (WFA        "Activate extended wavefunction analysis (requires External/libwfa submodule)."              OFF)
option (NEVPT2     "Activate (DMRG)-NEVPT2 support."                                                            OFF)
option (EFPLIB     "Enable EFPLib library for effective fragment potentials (requires External/efp submodule)." OFF)
option (GRID_IT    "Enable public GRID_IT code (requires External/grid_it submodule)."                          OFF)

################################################################################
#                                                                              #
# Global settings                                                              #
#                                                                              #
################################################################################

# mark that we are running CMake (for subprocesses)
set (ENV{CMAKE_SESSION} "OpenMolcas")

# project name and supported languages
#=====================================
message ("Configuring compilers:")

if (EFPLIB)
        cmake_minimum_required (VERSION 3.0.2)
endif ()
if (DMRG)
        project (Molcas Fortran C CXX)
        cmake_minimum_required (VERSION 3.2.0)
        if (NOT DEFINED QCMaquis_ROOT)
                if (DEFINED ENV{QCMaquis_ROOT})
                        set (QCMaquis_ROOT $ENV{QCMaquis_ROOT})
                else ()

=== Tools/CIsandbox/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#***********************************************************************
if (NOT DEFINED BASE_DIR)
        set (BASE_DIR ${PROJECT_SOURCE_DIR})
endif ()
file (RELATIVE_PATH tooldir ${BASE_DIR} ${CMAKE_CURRENT_LIST_DIR})
set (EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/${tooldir})

file (GLOB sources *.f90)

if (BIGOT)
        set (dir_error "disabled (not compatible with BIGOT)" PARENT_SCOPE)
        return()
endif ()

add_executable (caspt2_mini.exe ${sources})
target_link_libraries (caspt2_mini.exe molcas)
target_link_libraries (caspt2_mini.exe ${EXTERNAL_LIBRARIES})

=== Tools/dynamixtools/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#                                                                      *
# Copyright (C) 2015,2016,2019, Ignacio Fdez. Galván                   *
#***********************************************************************
if (NOT DEFINED BASE_DIR)
        set (BASE_DIR ${PROJECT_SOURCE_DIR})
endif ()
file (RELATIVE_PATH tooldir ${BASE_DIR} ${CMAKE_CURRENT_LIST_DIR})
set (EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/${tooldir})

if (PYTHONINTERP_FOUND)

        foreach (prog IN ITEMS dynamixtools)
                file (READ ${CMAKE_CURRENT_LIST_DIR}/${prog}.py content)
                file (WRITE ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/${prog}.py "#!/usr/bin/env ${PYTHON_EXECUTABLE}\n")
                file (APPEND ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/${prog}.py "${content}")
                file (COPY ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/${prog}.py
                      DESTINATION ${EXECUTABLE_OUTPUT_PATH}
                      FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
                )
        endforeach (prog)

else ()

        message (WARNING "No appropriate python interpreter found, dynamixtools will be disabled")

endif ()

=== Tools/grid2cube/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#                                                                      *
# Copyright (C) 2015,2016, Ignacio Fdez. Galván                        *
#***********************************************************************
if (NOT DEFINED BASE_DIR)
        set (BASE_DIR ${PROJECT_SOURCE_DIR})
endif ()
file (RELATIVE_PATH tooldir ${BASE_DIR} ${CMAKE_CURRENT_LIST_DIR})
set (EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/${tooldir})

foreach (prog IN ITEMS grid2cube)
        add_executable(${prog}.exe ${prog}.F90)
        file (COPY ${CMAKE_CURRENT_LIST_DIR}/${prog}.py
              DESTINATION ${EXECUTABLE_OUTPUT_PATH}
        )
endforeach (prog)

=== Tools/pymolcas/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#                                                                      *
# Copyright (C) 2017, Ignacio Fdez. Galván                             *
#***********************************************************************
if (NOT DEFINED BASE_DIR)
        set (BASE_DIR ${PROJECT_SOURCE_DIR})
endif ()
file (RELATIVE_PATH tooldir ${BASE_DIR} ${CMAKE_CURRENT_LIST_DIR})
set (OUTPUT_PATH ${PROJECT_BINARY_DIR}/${tooldir})

file (GLOB py_sources "*.py")
list (REMOVE_ITEM py_sources "${CMAKE_CURRENT_LIST_DIR}/pack.py")

if (NOT PYTHONINTERP_FOUND)
        set (dir_error "disabled (no appropriate python interpreter found)" PARENT_SCOPE)
        return()
endif ()

set (PYTHONINTERP_FOUND "${PYTHONINTERP_FOUND}" PARENT_SCOPE)

execute_process (
        COMMAND ${PYTHON_EXECUTABLE} imports.py
        WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
        OUTPUT_VARIABLE PYMOLCAS_IMPORT_OUTPUT
        RESULT_VARIABLE PYMOLCAS_IMPORT_RC
        OUTPUT_STRIP_TRAILING_WHITESPACE
        )

if (PYMOLCAS_IMPORT_RC)
        message (WARNING "Some python modules are not available: ${PYMOLCAS_IMPORT_OUTPUT}")
        set (dir_error "disabled" PARENT_SCOPE)
        return()
endif ()

set (PYMOLCAS_TARGET "${OUTPUT_PATH}/pymolcas_")
set (PYMOLCAS_TARGET "${PYMOLCAS_TARGET}" PARENT_SCOPE)

add_custom_command (OUTPUT ${PYMOLCAS_TARGET}
COMMAND ${PYTHON_EXECUTABLE} export.py ${PYMOLCAS_TARGET}
                WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
        DEPENDS ${py_sources}
        )

add_custom_target (pymolcas ALL
        DEPENDS ${PYMOLCAS_TARGET}
        )

add_custom_command (TARGET pymolcas
POST_BUILD
        COMMAND ${OPENMOLCAS_DIR}/sbin/install_pymolcas.sh ${PYMOLCAS_TARGET}
        )

=== Tools/rf2asc/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#                                                                      *
# Copyright (C) 2016, Ignacio Fdez. Galván                             *
#***********************************************************************
if (NOT DEFINED BASE_DIR)
        set (BASE_DIR ${PROJECT_SOURCE_DIR})
endif ()
file (RELATIVE_PATH tooldir ${BASE_DIR} ${CMAKE_CURRENT_LIST_DIR})
set (EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/${tooldir})

foreach (prog IN ITEMS rf2asc asc2rf testrf)
        add_executable(${prog}.exe ${prog}.f)
        target_link_libraries (${prog}.exe molcas)
        target_link_libraries (${prog}.exe ${EXTERNAL_LIBRARIES})
        target_include_directories (${prog}.exe PRIVATE
                ${PROJECT_SOURCE_DIR}/${runfile_util_src}
                )
endforeach (prog)

=== debian/changelog ===
openmolcas (19.11-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:22:07 +0100

openmolcas (19.11-1) unstable; urgency=medium

  * Initial release.

 -- Michael Banck <mbanck@debian.org>  Thu, 26 Dec 2019 20:57:17 +0100

=== debian/control ===
Source: openmolcas
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: debhelper (>= 10),
               cmake (>= 3.0.2),
               gfortran,
               libopenblas64-openmp-dev,
               libjs-jquery,
               libjs-underscore,
               python3-pyparsing,
               python3-six,
               python3-sphinx,
               python3-sphinxcontrib.bibtex
Standards-Version: 4.1.3
X-Python3-Version: >= 3.6
Homepage: https://gitlab.com/Molcas/OpenMolcas
Testsuite: autopkgtest-pkg-python
Vcs-Browser: https://salsa.debian.org/debichem-team/openmolcas
Vcs-Git: https://salsa.debian.org/debichem-team/openmolcas.git

Package: openmolcas
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${perl:Depends},
         openmolcas-data (= ${source:Version}),
         python3,
         python3-pyparsing,
         python3-six
Description: Quantum chemistry software package
 The key feature of OpenMolcas is the multiconfigurational approach to the
 electronic structure.

Package: openmolcas-data
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Quantum chemistry software package (data files)
 The key feature of OpenMolcas is the multiconfigurational approach to the
 electronic structure.
 .
 This package contains data files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --buildsystem=cmake --with sphinxdoc

override_dh_auto_configure:
	dh_auto_configure --		\
		-DTOOLS=ON		\
		-DOPENMP=ON		\
		-DLINALG=OpenBLAS	\
		-DOPENBLASROOT=/usr/include/${DEB_HOST_MULTIARCH}/openblas64-openmp \
		-DCMAKE_SKIP_RPATH=ON

override_dh_auto_build:
	#(cd obj-*; $(MAKE) doc_html)
	dh_auto_build

override_dh_auto_install:
	dh_auto_install
	cp obj-*/Tools/pymolcas/pymolcas_ debian/tmp/usr/bin/pymolcas
	cp -a test debian/tmp/usr/share/openmolcas

=== debian/watch ===
version=4
opts=filenamemangle=s/.*\/archive\/v(\d\S+)\/OpenMolcas.*\.tar\.gz/OpenMolcas-$1\.tar\.gz/g \
  https://gitlab.com/Molcas/OpenMolcas/tags?sort=updated_desc .*/archive/v(\d\S+)/.*\.tar\.gz.*

## openmolcas 20.10

=== CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#                                                                      *
# Copyright (C) 2014-2016, Steven Vancoillie                           *
#               2014-2020, Ignacio Fdez. Galván                        *
#               2015, Stefan Knecht                                    *
#               2020, Gerardo Raggi                                    *
#***********************************************************************
# Global CMakeLists.txt file for building OpenMolcas with CMake.
#
# Steven Vancoillie - Spring 2014, on a Saturday afternoon, with coffee
# Ignacio Fdez. Galván made several improvements / additions
# Lasse Sørensen - Mac CMP0042 fix
# Gerardo Raggi - MolGUI & AppleClang

project (OpenMolcas Fortran C)

cmake_minimum_required (VERSION 3.12.0)
#set (CMAKE_VERBOSE_MAKEFILE true)
if (POLICY CMP0042)
  cmake_policy (SET CMP0042 NEW)
endif ()
if (POLICY CMP0045)
  cmake_policy (SET CMP0045 NEW)
endif ()
if (POLICY CMP0074)
  cmake_policy (SET CMP0074 NEW)
endif ()
if (POLICY CMP0004)
  cmake_policy (SET CMP0004 NEW)
endif ()

# Prevent in-source builds
# If an in-source build is attempted, you will still need to clean up a few files manually.
set (CMAKE_DISABLE_SOURCE_CHANGES ON)
set (CMAKE_DISABLE_IN_SOURCE_BUILD ON)
get_filename_component (sourcedir "${CMAKE_SOURCE_DIR}" REALPATH)
get_filename_component (binarydir "${CMAKE_BINARY_DIR}" REALPATH)
if ("${sourcedir}" STREQUAL "${binarydir}")
  message (FATAL_ERROR "In-source builds in ${CMAKE_BINARY_DIR} are not "
          "allowed, please remove ./CMakeCache.txt and ./CMakeFiles/, create a "
          "separate build directory and run cmake from there.")
endif ()

# workaround for CMake bug 14874
# (i.e., fix for files with same name in different directories)
if (${CMAKE_VERSION} VERSION_LESS 3.1)
  if (NOT DEFINED CMAKE_Fortran_ARCHIVE_CREATE)
    set (CMAKE_Fortran_ARCHIVE_CREATE "<CMAKE_AR> cq <TARGET> <LINK_FLAGS> <OBJECTS>")
  endif ()
  if (NOT DEFINED CMAKE_Fortran_ARCHIVE_APPEND)
    set (CMAKE_Fortran_ARCHIVE_APPEND "<CMAKE_AR> q <TARGET> <LINK_FLAGS> <OBJECTS>")
  endif ()
  if (NOT DEFINED CMAKE_C_ARCHIVE_CREATE)
    set (CMAKE_C_ARCHIVE_CREATE "<CMAKE_AR> cq <TARGET> <LINK_FLAGS> <OBJECTS>")
  endif ()
  if (NOT DEFINED CMAKE_C_ARCHIVE_APPEND)
    set (CMAKE_C_ARCHIVE_APPEND "<CMAKE_AR> q <TARGET> <LINK_FLAGS> <OBJECTS>")
  endif ()
  if (NOT DEFINED CMAKE_CXX_ARCHIVE_CREATE)
    set (CMAKE_CXX_ARCHIVE_CREATE "<CMAKE_AR> cq <TARGET> <LINK_FLAGS> <OBJECTS>")
  endif ()
  if (NOT DEFINED CMAKE_CXX_ARCHIVE_APPEND)
    set (CMAKE_CXX_ARCHIVE_APPEND "<CMAKE_AR> q <TARGET> <LINK_FLAGS> <OBJECTS>")
  endif ()
endif ()

# discover some necessary tools
find_program (GIT "git")
find_program (PERL "perl")
mark_as_advanced (FORCE GIT PERL)

FIND_PACKAGE (PythonInterp 3.0)
if (NOT PYTHONINTERP_FOUND)
  FIND_PACKAGE (PythonInterp 2.7)
endif ()

################################################################################
#                                                                              #
# Options                                                                      #
#                                                                              #
################################################################################

# The build type, specifies the different optimization types.
if (NOT DEFINED CMAKE_BUILD_TYPE OR "${CMAKE_BUILD_TYPE}" STREQUAL "")
  set (CMAKE_BUILD_TYPE "Release" CACHE STRING
       "Type of build, options are: None (CFLAGS/FFLAGS can be used), Debug, Garble, RelWithDebInfo, Release, Fast."
       FORCE)
endif ()
set_property (CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS None Debug Garble RelWithDebInfo Release Fast)

# The place where OpenMolcas is installed with make install.
if (NOT DEFINED CMAKE_INSTALL_PREFIX)
  set (CMAKE_INSTALL_PREFIX "/opt/OpenMolcas" CACHE STRING
       "Location where OpenMolcas will be installed.")
endif ()
set (EXTRA_INSTALL_DIRS "")

set (DEBUG_DEFS "${DEBUG_DEFS}" CACHE STRING "Additional user-defined definitions.")
separate_arguments(DEBUG_DEFS)

option (BUILD_SHARED_LIBS "Build dynamically-linked molcas library." OFF)
option (BUILD_STATIC_LIB "Build statically-linked molcas library too." OFF)
if (BUILD_SHARED_LIBS)
  mark_as_advanced (CLEAR BUILD_STATIC_LIB)
else ()
  mark_as_advanced (FORCE BUILD_STATIC_LIB)
endif ()

option (MPI "Enable MPI parallellization." OFF)
option (GA "Use Global Arrays library." OFF)

option (OPENMP "Enable multi-threading." OFF)

option (BOUNDS "Enable bounds checking (only gfortran >= 4.8)." OFF)

option (EXPERT "Show advanced CMake cache entries in GUI)." OFF)

option (BIGOT "Do not allow any compiler warning (treat them as errors)." OFF)

set (LINALG_OPTIONS "Choose linear algebra library, options: Internal (default), Runtime, MKL, OpenBLAS, ACML, Accelerate.")
if (DEFINED LINALG)
  set (LINALG "${LINALG}" CACHE STRING "${LINALG_OPTIONS}")
  if (NOT ";Internal;Runtime;MKL;OpenBLAS;ACML;Accelerate;" MATCHES ";${LINALG};")
      message (FATAL_ERROR "Unsuported LINALG: ${LINALG}")
  endif ()
else ()
  set (LINALG "Internal" CACHE STRING "${LINALG_OPTIONS}")
endif ()
set_property (CACHE LINALG PROPERTY STRINGS Internal Runtime MKL OpenBLAS ACML Accelerate)

option (CUBLAS "Enable CUDA BLAS library." OFF)
option (NVBLAS "Enable NVidia BLAS library." OFF)

option (FDE "Enable Frozen-density-embedding (FDE) interface." OFF)
option (GROMACS "Compile Gromacs interface." OFF)
option (BLOCK "Activate BLOCK-DMRG support." OFF)
option (CHEMPS2 "Activate CheMPS2-DMRG support." OFF)

option (GPERFTOOLS "Activate gperftools CPU profiling." OFF)
option (GCOV "Activate code coverage profiling (use with Debug/-O0)." OFF)
option (HDF5 "Activate HDF5 support for wavefunction format." ON)

option (TOOLS "Compile supported tools." OFF)

option (BUILD_TESTING "Build the unit_tests." ON)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_compile_definitions(_ADDITIONAL_RUNTIME_CHECK_)
endif()

if (";Debug;Garble;RelWithDebInfo;" MATCHES ";${CMAKE_BUILD_TYPE};" OR BIGOT)
    add_compile_definitions(_WARNING_WORKAROUND_)
endif()


# External projects
option (MSYM       "Activate MSYM support (requires External/libmsym submodule)." OFF)
option (DMRG       "Activate QCMaquis DMRG driver and library."                   OFF)
option (DMRG_DEBUG "Enable DEBUG print in QCMaquis driver."                       OFF)
option (MolGUI     "Enable the Molcas Graphical User Interface."                  OFF)

if (DMRG)
  mark_as_advanced (CLEAR DMRG_DEBUG)
  # Name and e-mail required for downloading QCMaquis
  # Try to get the real name from the system account information
  if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set (QCMaquis_NAME_GET_CMD "id -F")
  else ()
  # should we distinguish other platforms?
    set (QCMaquis_NAME_GET_CMD "sh" "-c" "getent passwd $USER | awk -F: '{print \$5}'")
  endif ()
  execute_process (
    COMMAND ${QCMaquis_NAME_GET_CMD}
    OUTPUT_VARIABLE QCMaquis_NAME_
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  set (QCMaquis_NAME ${QCMaquis_NAME_} CACHE STRING "Your name (required for downloading QCMaquis)")

  # Update QCMaquis flag. Off by default.
  # QCMaquis must be updated manually, as there might be QCMaquis upstream changes even when OpenMolcas is not changed,
  # or vice versa. Running cmake with QCMaquis_UPDATE=ON will force-update QCMaquis.
  if (NOT QCMaquis_UPDATE)
    set (QCMaquis_UPDATE OFF CACHE STRING "Trigger QCMaquis update" FORCE)
  endif ()

  # try to get the e-mail address from git config (TODO: is there a better option?)
  execute_process (
    COMMAND ${GIT} "config" "user.email"
    OUTPUT_VARIABLE QCMaquis_EMAIL_
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  set (QCMaquis_EMAIL ${QCMaquis_EMAIL_} CACHE STRING "Your e-mail address (required for downloading QCMaquis)")

  # Prepare variables for QCMaquis: separate name and surname
  set (QCMaquis_NAME_LIST ${QCMaquis_NAME})

  separate_arguments (QCMaquis_NAME_LIST)
  list (LENGTH QCMaquis_NAME_LIST qcm_name_len)
  if (qcm_name_len LESS 2)
    message (FATAL_ERROR
             "Your name has been specified as: " ${QCMaquis_NAME} "\n"
             "Please specify both name and surname. If you have only one name, please specify it twice.")
  endif ()

  # Separate first name from the last name
  # Currently, only the first word is treated by QCMaquis as the first name,
  # all the rest is considered surnames -- to accomodate multiple surnames common in the Spanish-speaking
  # areas or suffixes as Jr., III etc. Middle names are therefore incorrectly considered parts of
  # the last name. However, this has no influence on the QCMaquis download.
  list (GET QCMaquis_NAME_LIST 0 QCMaquis_GIVEN_NAME)
  list (REMOVE_AT QCMaquis_NAME_LIST 0)
  foreach (arg ${QCMaquis_NAME_LIST})
    set (QCMaquis_SURNAME "${QCMaquis_SURNAME} ${arg}")
  endforeach ()

  # Set QCMaquis download URL and path to the download script
  set (QCMaquis_URL "https://scine.ethz.ch/download/")
  set (QCMaquis_dl_SCRIPT "${CMAKE_SOURCE_DIR}/src/qcmaquis/get_qcmaquis.sh")
else ()
  mark_as_advanced (FORCE DMRG_DEBUG)
endif ()
option (GEN1INT    "Enable Gen1Int library for 1-electron integrals."                                           OFF)
option (NECI       "Activate NECI support (requires External/NECI submodule)."                                  OFF)
option (WFA        "Activate extended wavefunction analysis (requires External/libwfa submodule)."              OFF)
option (NEVPT2     "Activate (DMRG)-NEVPT2 support."                                                            OFF)
option (EFPLIB     "Enable EFPLib library for effective fragment potentials (requires External/efp submodule)." OFF)

################################################################################
#                                                                              #
# Global settings                                                              #
#                                                                              #
################################################################################

# mark that we are running CMake (for subprocesses)
set (ENV{CMAKE_SESSION} "OpenMolcas")

# project name and supported languages
#=====================================
message ("Configuring compilers:")

if (DMRG)
  enable_language (CXX)
  if (NOT DEFINED QCMaquis_ROOT)
    if (DEFINED ENV{QCMaquis_ROOT})
      set (QCMaquis_ROOT $ENV{QCMaquis_ROOT})
    else ()
      set (QCMaquis_ROOT "None")
    endif ()
    set (QCMaquis_ROOT ${QCMaquis_ROOT} CACHE STRING "Specify path to existing QCMaquis installation. This will allow to skip the installation of ALPS/BOOST and QCMaquis.")
  endif ()
endif ()

if (WFA OR MolGUI)
  enable_language (CXX)
endif ()

#avoid using CXX compiler for linking
set (CMAKE_CXX_LINKER_PREFERENCE_PROPAGATES FALSE)

add_definitions (-D_MOLCAS_)

#set cmake module search paths
set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH})

# location of molcas-extra
if (NOT DEFINED EXTRA)
  if (DEFINED ENV{EXTRA})
    set (EXTRA $ENV{EXTRA})
  else ()
    set (EXTRA "")
  endif ()
endif ()
if (NOT "${EXTRA}" STREQUAL "")
  if (NOT IS_ABSOLUTE "${EXTRA}")
    set (EXTRA "${PROJECT_BINARY_DIR}/${EXTRA}")
  endif ()
  get_filename_component (EXTRA "${EXTRA}" ABSOLUTE)
  if (NOT EXISTS "${EXTRA}")

=== unit_tests/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#                                                                      *
# Copyright (C) 2020, Oskar Weser                                      *
#***********************************************************************

include_guard(GLOBAL)

include(${PROJECT_SOURCE_DIR}/cmake/cmake_helpers.cmake)

set(UNIT_TEST_BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR})

function(add_unit_test Target)
    add_directory(../fruit_molcas)

    add_executable(${Target} ${ARGN})

    target_link_libraries(${Target} fruit_molcas mods_obj molcas ${EXTERNAL_LIBRARIES})

    set_target_properties(${Target}
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY
            "${UNIT_TEST_BUILD_DIR}/bin")

    add_test(
        NAME
            ${Target}
        COMMAND
            $<TARGET_FILE:${Target}>)

    set_tests_properties(
        ${Target}
        PROPERTIES
            ENVIRONMENT "MOLCAS_MEM=1000")
endfunction()


# And start adding tests
add_subdirectory(linalg_mod/)
add_subdirectory(fortran_strings/)

=== Tools/CIsandbox/CMakeLists.txt ===
--- 
+++ 
@@ -14,13 +14,15 @@
 file (RELATIVE_PATH tooldir ${BASE_DIR} ${CMAKE_CURRENT_LIST_DIR})
 set (EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/${tooldir})
 
+file (GLOB data *.DAT)
+
+foreach (datafile ${data})
+        file (COPY ${datafile} DESTINATION ${EXECUTABLE_OUTPUT_PATH})
+endforeach (datafile)
+
 file (GLOB sources *.f90)
-
-if (BIGOT)
-        set (dir_error "disabled (not compatible with BIGOT)" PARENT_SCOPE)
-        return()
-endif ()
 
 add_executable (caspt2_mini.exe ${sources})
 target_link_libraries (caspt2_mini.exe molcas)
 target_link_libraries (caspt2_mini.exe ${EXTERNAL_LIBRARIES})
+

=== Tools/job2asc/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#***********************************************************************
if (NOT DEFINED BASE_DIR)
        set (BASE_DIR ${PROJECT_SOURCE_DIR})
endif ()
file (RELATIVE_PATH tooldir ${BASE_DIR} ${CMAKE_CURRENT_LIST_DIR})
set (EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/${tooldir})

foreach (prog IN ITEMS job2asc asc2job)
        add_executable(${prog}.exe ${prog}.f)
        target_link_libraries (${prog}.exe molcas)
        target_link_libraries (${prog}.exe ${EXTERNAL_LIBRARIES})
endforeach (prog)

=== unit_tests/fortran_strings/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#                                                                      *
# Copyright (C) 2020, Oskar Weser                                      *
#***********************************************************************

include(${PROJECT_SOURCE_DIR}/cmake/cmake_helpers.cmake)

set(not_supported ";SunPro;PGI;")

if (NOT ((CMAKE_Fortran_COMPILER_ID IN_LIST not_supported) OR (CMAKE_Fortran_COMPILER_ID STREQUAL "Intel" AND CMAKE_Fortran_COMPILER_VERSION VERSION_LESS "14")))
    add_unit_test(test_fortran_strings test_fortran_strings.F90)
endif()

=== unit_tests/linalg_mod/CMakeLists.txt ===
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#                                                                      *
# Copyright (C) 2020, Oskar Weser                                      *
#***********************************************************************

include(${PROJECT_SOURCE_DIR}/cmake/cmake_helpers.cmake)

set(not_supported ";SunPro;PGI;")

if (NOT ((CMAKE_Fortran_COMPILER_ID IN_LIST not_supported) OR (CMAKE_Fortran_COMPILER_ID STREQUAL "Intel" AND CMAKE_Fortran_COMPILER_VERSION VERSION_LESS "14")))
    add_unit_test(test_linalg test_linalg.F90)
endif()

=== debian/changelog ===
openmolcas (20.10-2) unstable; urgency=medium

  * debian/rules (FFLAGS): New environment variable, add
    -fno-expensive-optimizations to the default Fortran flags.

 -- Michael Banck <mbanck@debian.org>  Sat, 02 Jan 2021 00:52:15 +0100

openmolcas (20.10-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/mkl_library_dir.patch: Refreshed.
  * debian/patches/pymolcas_default_directories.patch: Likewise.
  * debian/patches/verify_default_directories.patch: Likewise.
  * debian/patches/install_locations.patch: Likewise.
  * debian/patches/openblas_hardcode_includedir.patch: Likewise.
  * debian/patches/linux_platform_support.patch: Likewise.
  * debian/patches/cisandbox_compilation_fixes.patch: Removed, no longer
    needed.
  * debian/patches/fix_doc_build.patch: Likewise.

 -- Michael Banck <mbanck@debian.org>  Fri, 01 Jan 2021 16:40:25 +0100

openmolcas (19.11-5) unstable; urgency=medium

  * Reuploading from the git repository, the 19.11-4 source package in the
    Debian archive has additional changes which makes it FTFBS, Closes:
    #960820.

 -- Michael Banck <mbanck@debian.org>  Mon, 18 May 2020 22:01:21 +0200

openmolcas (19.11-4) unstable; urgency=medium

  * debian/tests/testsuite.sh: Include test 001, as it failed on the arm64
    debci builder.

 -- Michael Banck <mbanck@debian.org>  Fri, 06 Mar 2020 13:19:44 +0100

openmolcas (19.11-3) unstable; urgency=medium

  * debian/tests/testsuite.sh: Dump output/error files if test cases fail.
  * debian/openmolcas.install: Install the following additional pymolcas
    scripts: find_sources, have_feature, help_basis, help_doc, modulenames.plx,
    updatetest.plx and version.
  * debian/tests/testsuite.sh: Only run a small subset of tests.

 -- Michael Banck <mbanck@debian.org>  Thu, 05 Mar 2020 22:55:06 +0100

openmolcas (19.11-2) unstable; urgency=medium

  * debian/control (Description): Add main capabilities.
  * debian/patches/linux_platform_support.patch: New patch, sets PLATFORM to
    Linux independent of CPU type. 

 -- Michael Banck <mbanck@debian.org>  Wed, 04 Mar 2020 10:02:44 +0100

=== debian/control ===
--- 
+++ 
@@ -32,6 +32,25 @@
 Description: Quantum chemistry software package
  The key feature of OpenMolcas is the multiconfigurational approach to the
  electronic structure.
+ .
+ It can compute energies, gradients and hessians for the following methods:
+  * Hartree-Fock SCF (HF)
+  * Complete active space SCF (CASSCF)
+ .
+ It can compute energies and gradients for the following methods:
+  * Hartree-Fock (HF)
+  * Density-Functional Theory (DFT)
+  * Second-order Moeller-Plesset perturbation theory (MP2)
+  * Complete and restricted active space SCF (CASSCF/RASSCF)
+ .
+ Additionally, it can compute energies for the following methods:
+  * Closed shell Moeller-Plesset perturbation theory (MP2)
+  * Complete active space second order perturbation theory (CASPT2)
+  * Coupled-cluster singles doubles (CCSD), optionally wihth
+    Cholesky-Decomposition (CD)/Resolution-of-the Identity (RI)
+  * CD/RI Coupled-cluster singles doubles with perturbative
+    triples (CCSD(T))
+  * Density Matrix Renormalization Group SCF (DMRG-SCF)
 
 Package: openmolcas-data
 Architecture: all

=== debian/rules ===
--- 
+++ 
@@ -5,6 +5,8 @@
 # export DH_VERBOSE=1
 
 DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+
+export FFLAGS=$(shell dpkg-buildflags --get FFLAGS) -fno-expensive-optimizations
 
 %:
 	dh $@ --buildsystem=cmake --with sphinxdoc
